////////////////////////////////////////////////////////////////
// ライフゲームガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview ライフゲーム
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * Option。
 *
 * @constructor
 */
lifegame.Option = aaoh.kaze.Gadget.extend(
	aaoh.sora.OptionEx, function() {
});
	/**
	 * 設定データの設定。
	 */
	lifegame.Option.prototype.
	doOption = function() {
		// type
		for (var cnt = 1; cnt <= 3; cnt++) {
			var rdoType = aaoh.kaze.Gadget.$('rdoType' + cnt);
			var flgType = aaoh.kaze.Element.isChecked(rdoType);

			if (flgType) {
				aaoh.sora.App.model.data.type = String(cnt);
				break;
			}
		}

		// numInterval
		for (
			var cnt = 0;
			cnt < aaoh.sora.App.control.LST_INTERVAL.length;
			cnt++
		) {
			var numInterval = aaoh.sora.App.control.LST_INTERVAL[cnt];
			var selInterval
				= aaoh.kaze.Gadget.$('selInterval_' + numInterval);
			var flgInterval = aaoh.kaze.Element.isSelected(selInterval);

			if (flgInterval) {
				aaoh.sora.App.model.data.numInterval = numInterval;
				break;
			}
		}

		// ptnDef
		for (var cnt = 1; cnt <= aaoh.sora.App.control.PTN.length; cnt++) {
			var selPtnDef = aaoh.kaze.Gadget.$('selPtnDef_' + cnt);
			var flgPtnDef = aaoh.kaze.Element.isSelected(selPtnDef);

			if (flgPtnDef) {
				aaoh.sora.App.model.data.ptnDef = String(cnt);
				break;
			}
		}
	}

	/**
	 * 表示データの初期化。
	 */
	lifegame.Option.prototype.
	initData = function() {
		this.initTitleData();
		this.initDefaultData();
	}

	/**
	 * 表示データの初期化(タイトル)。
	 */
	lifegame.Option.prototype.
	initTitleData = function() {
		var lblType      = aaoh.kaze.Gadget.$('lblType');
		var lblType1     = aaoh.kaze.Gadget.$('lblType1');
		var lblType2     = aaoh.kaze.Gadget.$('lblType2');
		var lblType3     = aaoh.kaze.Gadget.$('lblType3');
		var lblInterval  = aaoh.kaze.Gadget.$('lblInterval');
		var selInterval1 = aaoh.kaze.Gadget.$('selInterval_100');
		var selInterval2 = aaoh.kaze.Gadget.$('selInterval_500');
		var selInterval3 = aaoh.kaze.Gadget.$('selInterval_1000');
		var lblPtnDef    = aaoh.kaze.Gadget.$('lblPtnDef');
		var selPtnDef1   = aaoh.kaze.Gadget.$('selPtnDef_1');
		var selPtnDef2   = aaoh.kaze.Gadget.$('selPtnDef_2');
		var selPtnDef3   = aaoh.kaze.Gadget.$('selPtnDef_3');
		var selPtnDef4   = aaoh.kaze.Gadget.$('selPtnDef_4');
		var selPtnDef5   = aaoh.kaze.Gadget.$('selPtnDef_5');

		var ttlType      = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1     = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2     = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3     = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlInterval  = aaoh.sora.App.control.locale.getString('TTL_INTERVAL');
		var ttlInterval1 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL1');
		var ttlInterval2 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL2');
		var ttlInterval3 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL3');
		var ttlPtnDef    = aaoh.sora.App.control.locale.getString('TTL_PTN_DEF');
		var ttlPtn1      = aaoh.sora.App.control.locale.getString('TTL_PTN1');
		var ttlPtn2      = aaoh.sora.App.control.locale.getString('TTL_PTN2');
		var ttlPtn3      = aaoh.sora.App.control.locale.getString('TTL_PTN3');
		var ttlPtn4      = aaoh.sora.App.control.locale.getString('TTL_PTN4');
		var ttlPtn5      = aaoh.sora.App.control.locale.getString('TTL_PTN5');

		aaoh.kaze.Element.setValue(lblType,           ttlType);
		aaoh.kaze.Element.setValue(lblType1,          ttlType1);
		aaoh.kaze.Element.setValue(lblType2,          ttlType2);
		aaoh.kaze.Element.setValue(lblType3,          ttlType3);
		aaoh.kaze.Element.setValue(lblInterval,       ttlInterval);
		aaoh.kaze.Element.setInnerValue(selInterval1, ttlInterval1);
		aaoh.kaze.Element.setInnerValue(selInterval2, ttlInterval2);
		aaoh.kaze.Element.setInnerValue(selInterval3, ttlInterval3);
		aaoh.kaze.Element.setValue(lblPtnDef,         ttlPtnDef);
		aaoh.kaze.Element.setInnerValue(selPtnDef1,   ttlPtn1);
		aaoh.kaze.Element.setInnerValue(selPtnDef2,   ttlPtn2);
		aaoh.kaze.Element.setInnerValue(selPtnDef3,   ttlPtn3);
		aaoh.kaze.Element.setInnerValue(selPtnDef4,   ttlPtn4);
		aaoh.kaze.Element.setInnerValue(selPtnDef5,   ttlPtn5);
	}

	/**
	 * 表示データの初期化(デフォルト)。
	 */
	lifegame.Option.prototype.
	initDefaultData = function() {
		// type
		var rdoType = aaoh.kaze.Gadget.$(
			'rdoType' + aaoh.sora.App.model.data.type
		);
		aaoh.kaze.Element.setChecked(rdoType, true);

		// numInterval
		var selInterval = aaoh.kaze.Gadget.$(
			'selInterval_' + aaoh.sora.App.model.data.numInterval
		)
		aaoh.kaze.Element.setSelected(selInterval, true);

		// ptnDef
		var selPtnDef = aaoh.kaze.Gadget.$(
			'selPtnDef_' + aaoh.sora.App.model.data.ptnDef
		)
		aaoh.kaze.Element.setSelected(selPtnDef, true);
	}

	/**
	 * 表示データの初期化(Yahoo)。
	 */
	lifegame.Option.prototype.
	initDataForYahoo = function() {
		var ttlType      = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1     = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2     = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3     = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlInterval  = aaoh.sora.App.control.locale.getString('TTL_INTERVAL');
		var ttlInterval1 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL1');
		var ttlInterval2 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL2');
		var ttlInterval3 = aaoh.sora.App.control.locale.getString('TTL_INTERVAL3');
		var ttlPtnDef    = aaoh.sora.App.control.locale.getString('TTL_PTN_DEF');
		var ttlPtn1      = aaoh.sora.App.control.locale.getString('TTL_PTN1');
		var ttlPtn2      = aaoh.sora.App.control.locale.getString('TTL_PTN2');
		var ttlPtn3      = aaoh.sora.App.control.locale.getString('TTL_PTN3');
		var ttlPtn4      = aaoh.sora.App.control.locale.getString('TTL_PTN4');
		var ttlPtn5      = aaoh.sora.App.control.locale.getString('TTL_PTN5');

		preferences.type.title            = ttlType;
		preferences.type.option[0]        = ttlType1;
		preferences.type.option[1]        = ttlType2;
		preferences.type.option[2]        = ttlType3;
		preferences.numInterval.title     = ttlInterval;
		preferences.numInterval.option[0] = ttlInterval1;
		preferences.numInterval.option[1] = ttlInterval2;
		preferences.numInterval.option[2] = ttlInterval3;
		preferences.ptnDef.title          = ttlPtnDef;
		preferences.ptnDef.option[0]      = ttlPtn1;
		preferences.ptnDef.option[1]      = ttlPtn2;
		preferences.ptnDef.option[2]      = ttlPtn3;
		preferences.ptnDef.option[3]      = ttlPtn4;
		preferences.ptnDef.option[4]      = ttlPtn5;
	}

	/**
	 * イベントの設定。
	 */
	lifegame.Option.prototype.
	setEventListener = function() {
		// 何もなし
	}

	/**
	 * 初期化処理。
	 */
	lifegame.Option.prototype.
	init = function() {
		this.setEventListener();
	}
})();
